// implements the btk protocol
#ifndef __BTKCAM_CLIENT_H__
#define __BTKCAM_CLIENT_H__

// ------------------------------------ btkcam client class declarations --------------------------------------

class btkcam_client
{
	public:
	btkcam_client(char *server_url, unsigned int timeout);
	~btkcam_client(void);
	
	// configuration related
	char hostname[128];
	char provscas[2048];
	int  pcant;
	unsigned int status;
	bool dbg;
	
	//control words
	unsigned char cw_0[8];
	unsigned char cw_1[8];
	char answer[2048];
	unsigned char lastcmd[512];
	int  lastcmdsize;

	//verbs
	bool ready;
	bool is_ready( void );
	int  HasPC ( char* provcaid);
	void checknet(unsigned char *data, int lent);

	private:
	int fd; //file descriptor for network connections.
	int network_timeout;
	int netflags;
	timeval tval;			// timeout
    	fd_set fdset;			// select fdset
    	int fdret;			// select return value   0 timeout, -1 error disconnect, 
	int optval;			//getsockopt
	socklen_t optlen;		// getsockopt

	
	char url[255];
	//char hostname[128];
	unsigned int port;
	char username[16];
	char password[16];
	char passwkey[16];
	
	bool encryption;		// if passwkey empty or wrong no enc/dec function.
	
	//misc
	void server_connect( void );
	void server_disconnect( void );
	void parse_url( void );
	int  btkdecrypt (unsigned char* message, int msglen, char *keyiv);
	int  btkcrypt (unsigned char* message, int msglen, char *keyiv);

};
#endif

